#Persistent
#SingleInstance force
StringCaseSense, On
SetTitleMatchMode, RegEx

MenuFile = %A_AppData%\SketchUSizer.txt

IfNotExist, %MenuFile%
    WriteDefaultMenu(MenuFile)

Menu, Tray, NoStandard
Menu, Tray, Add, Sketch-U-Sizer, DoEdit
menu, Tray, Add

Loop, Read, %MenuFile%
{
    If RegExMatch(A_LoopReadLine, "^\d{3,4}[xX]\d{3,4}\s*$")
        Menu, Tray, Add, %A_LoopReadLine%, Resize
    If RegExMatch(A_LoopReadLine,"^---")
        Menu, Tray, Add
}

Menu, Tray, Add 
Menu, Tray, Add, Edit Sizes, DoEdit
Menu, Tray, Add 
Menu, Tray, Add, Exit, Exit
Menu, Tray, Tip, Sketch-U-Sizer
IfExist, sketchusizer.ico, Menu, Tray, Icon, sketchusizer.ico

Return

DoEdit:
RunWait, notepad.exe "%MenuFile%
Reload
Return

Exit:
ExitApp
Return

Resize:
    hwnd := FindSketchup()
    hCtrl := FindDrawingAreaControl(hwnd)
    IfEqual, hCtrl,, Return
    WinRestore, ahk_id %hwnd%
    WinActivate, ahk_id %hwnd%
    StringSplit, size, A_ThisMenuItem, x
    tW := size1, tH := size2
    Loop, 2
    {
        WinGetPos, wXPos, wYPos, wW, wH, ahk_id %hwnd%
        ControlGetPos, cx, cy, cw, ch,, ahk_id %hCtrl%
        twW := tW + (wW - cw) + 4
        twH := tH + (wH - ch) + 4
        ;msgbox % "cx" cx " cy" cy " cw" cw-4 " ch" ch-4
        if (ch <> twH or cw <> twW)
            WinMove, ahk_id %hwnd%, , wXPos, wYPos, twW, twH
    }
    ControlGetPos, cx, cy, cw, ch,, ahk_id %hCtrl%
    msgbox, , Sketch-U-Sizer, % "Final size:`n"cw-4 " x " ch-4
Return

FindSketchup()
{
    WinGet, wid, ID, \b(Untitled|\w+\.skp) - SketchUp\b
    Return wid
}

FindDrawingAreaControl(hwnd)
{
    WinGet, clist, ControlList, ahk_id %hwnd%
    Loop, Parse, clist, `n
    {
        if InStr(A_LoopField, "AfxFrameorView")
            ControlGet, hctrl, Hwnd, , %A_LoopField%, ahk_id %hwnd%
        Break
    }
    Return hctrl
}
WriteDefaultMenu(mnuFile)
{
    contents =
    (LTrim
    ; 
    ; This is the Sketch-U-Sizer menu file. It is a plain
    ; text file which should be edited using a plain-text
    ; editor, such as notepad.exe.
    ;
    ;  == File Format ==
    ; One line per menu item, in the form WIDTHxHEIGHT in pixels.
    ; Minimums and Mamimums for both width and height is 100-9999 pixels. 
    ; Comments start with the semi-colon ( ; ) character.
    ; Comments and blank lines are skipped. (Feel free to delete these comments anytime.)
    ; Three dashes (---) adds a menu separator.
    ;
    ; Once you have finished editing, save and close this file.
    ; Sketch-U-Sizer will then refresh its menus.
    ;
    ; Here are some examples to get you started:

    500x500
    ---
    640x480
    800x600
    1024x768


    )
    FileAppend, `;`n`; File: %mnuFile%`n`;`n, %mnuFile%
    FileAppend, %contents%, %mnuFile%
}
